;--------------------------------------------------------------------------------------------------
;
; : ignition.asm
;
; : 2.0
;
; : 24.10.2014, 15:52:11
;
; :    .
;              IgnitionMaster.
;
; : 
;            - PIC16F628   
;           
;             -   -  
;           
;              - 2 
;                     - 3.3  19.5  30.5  35.1  38.2  40.7  40.0    
;           
;            1 - 1 
;                     - 2.2  12.3  21.8  26.3  27.3  27.9  27.5    
;           
;            2 - 3 
;                     - 6.5  28.2  39.3  43.9  45.5  45.0  45.0    
;           
;             1 - -
;           
;             2 -   3500 /
;           
;--------------------------------------------------------------------------------------------------




;  --------------------------------------------------------------------------------------

    LIST    p=16f628

#define PIC16F628




;--------------------------------------------------------------------------------------------------
;       Register Definitions
;--------------------------------------------------------------------------------------------------

W                            EQU     H'0000'
F                            EQU     H'0001'

;----- Register Files------------------------------------------------------------------------------

INDF                         EQU     H'0000'
TMR0                         EQU     H'0001'
PCL                          EQU     H'0002'
STATUS                       EQU     H'0003'
FSR                          EQU     H'0004'
PORTA                        EQU     H'0005'
PORTB                        EQU     H'0006'
PCLATH                       EQU     H'000A'
INTCON                       EQU     H'000B'
PIR1                         EQU     H'000C'
TMR1L                        EQU     H'000E'
TMR1H                        EQU     H'000F'
T1CON                        EQU     H'0010'
TMR2                         EQU     H'0011'
T2CON                        EQU     H'0012'
CCPR1L                       EQU     H'0015'
CCPR1H                       EQU     H'0016'
CCP1CON                      EQU     H'0017'
RCSTA                        EQU     H'0018'
TXREG                        EQU     H'0019'
RCREG                        EQU     H'001A'
CMCON                        EQU     H'001F'

OPTION_REG                   EQU     H'0081'
TRISA                        EQU     H'0085'
TRISB                        EQU     H'0086'
PIE1                         EQU     H'008C'
PCON                         EQU     H'008E'
PR2                          EQU     H'0092'
TXSTA                        EQU     H'0098'
SPBRG                        EQU     H'0099'
EEDATA                       EQU     H'009A'
EEADR                        EQU     H'009B'
EECON1                       EQU     H'009C'
EECON2                       EQU     H'009D'
VRCON                        EQU     H'009F'

;----- STATUS Bits --------------------------------------------------------------------------------

IRP                          EQU     H'0007'
RP1                          EQU     H'0006'
RP0                          EQU     H'0005'
NOT_TO                       EQU     H'0004'
NOT_PD                       EQU     H'0003'
Z                            EQU     H'0002'
DC                           EQU     H'0001'
C                            EQU     H'0000'

;----- INTCON Bits --------------------------------------------------------------------------------

GIE                          EQU     H'0007'
PEIE                         EQU     H'0006'
T0IE                         EQU     H'0005'
INTE                         EQU     H'0004'
RBIE                         EQU     H'0003'
T0IF                         EQU     H'0002'
INTF                         EQU     H'0001'
RBIF                         EQU     H'0000'

;----- PIR1 Bits ----------------------------------------------------------------------------------

EEIF                         EQU     H'0007'
CMIF                         EQU     H'0006'
RCIF                         EQU     H'0005'
TXIF                         EQU     H'0004'
CCP1IF                       EQU     H'0002'
TMR2IF                       EQU     H'0001'
TMR1IF                       EQU     H'0000'

;----- T1CON Bits ---------------------------------------------------------------------------------
T1CKPS1                      EQU     H'0005'
T1CKPS0                      EQU     H'0004'
T1OSCEN                      EQU     H'0003'
NOT_T1SYNC                   EQU     H'0002'
TMR1CS                       EQU     H'0001'
TMR1ON                       EQU     H'0000'

;----- T2CON Bits ---------------------------------------------------------------------------------
TOUTPS3                      EQU     H'0006'
TOUTPS2                      EQU     H'0005'
TOUTPS1                      EQU     H'0004'
TOUTPS0                      EQU     H'0003'
TMR2ON                       EQU     H'0002'
T2CKPS1                      EQU     H'0001'
T2CKPS0                      EQU     H'0000'

;----- CCP1CON Bits -------------------------------------------------------------------------------
CCP1X                        EQU     H'0005'
CCP1Y                        EQU     H'0004'
CCP1M3                       EQU     H'0003'
CCP1M2                       EQU     H'0002'
CCP1M1                       EQU     H'0001'
CCP1M0                       EQU     H'0000'

;----- RCSTA Bits ---------------------------------------------------------------------------------
SPEN                         EQU     H'0007'
RX9                          EQU     H'0006'
SREN                         EQU     H'0005'
CREN                         EQU     H'0004'
ADEN                         EQU     H'0003'
FERR                         EQU     H'0002'
OERR                         EQU     H'0001'
RX9D                         EQU     H'0000'

;----- CMCON Bits ---------------------------------------------------------------------------------

C2OUT                        EQU     H'0007'
C1OUT                        EQU     H'0006'
C2INV                        EQU     H'0005'
C1INV                        EQU     H'0004'
CIS                          EQU     H'0003'
CM2                          EQU     H'0002'
CM1                          EQU     H'0001'
CM0                          EQU     H'0000'

;----- OPTION Bits --------------------------------------------------------------------------------

NOT_RBPU                     EQU     H'0007'
INTEDG                       EQU     H'0006'
T0CS                         EQU     H'0005'
T0SE                         EQU     H'0004'
PSA                          EQU     H'0003'
PS2                          EQU     H'0002'
PS1                          EQU     H'0001'
PS0                          EQU     H'0000'

;----- PIE1 Bits ----------------------------------------------------------------------------------

EEIE                         EQU     H'0007'
CMIE                         EQU     H'0006'
RCIE                         EQU     H'0005'
TXIE                         EQU     H'0004'
CCP1IE                       EQU     H'0002'
TMR2IE                       EQU     H'0001'
TMR1IE                       EQU     H'0000'

;----- PCON Bits ----------------------------------------------------------------------------------

OSCF                         EQU     H'0003'
NOT_POR                      EQU     H'0001'
NOT_BO                       EQU     H'0000'
NOT_BOR                      EQU     H'0000'
NOT_BOD                      EQU     H'0000'

;----- TXSTA Bits ---------------------------------------------------------------------------------
CSRC                         EQU     H'0007'
TX9                          EQU     H'0006'
TXEN                         EQU     H'0005'
SYNC                         EQU     H'0004'
BRGH                         EQU     H'0002'
TRMT                         EQU     H'0001'
TX9D                         EQU     H'0000'

;----- EECON1 Bits --------------------------------------------------------------------------------
WRERR                        EQU     H'0003'
WREN                         EQU     H'0002'
WR                           EQU     H'0001'
RD                           EQU     H'0000'

;----- VRCON Bits ---------------------------------------------------------------------------------

VREN                         EQU     H'0007'
VROE                         EQU     H'0006'
VRR                          EQU     H'0005'
VR3                          EQU     H'0003'
VR2                          EQU     H'0002'
VR1                          EQU     H'0001'
VR0                          EQU     H'0000'

;--------------------------------------------------------------------------------------------------
;       RAM Definition
;--------------------------------------------------------------------------------------------------

    __MAXRAM H'01FF'
    __BADRAM H'07'-H'09', H'0D', H'13'-H'14', H'1B'-H'1E'
    __BADRAM H'87'-H'89', H'8D', H'8F'-H'91', H'93'-H'97', H'9E'
    __BADRAM H'105', H'107'-H'109', H'10C'-H'11F', H'150'-H'16F'
    __BADRAM H'185', H'187'-H'189', H'18C'-H'1EF'

;--------------------------------------------------------------------------------------------------
;       Configuration Bits
;--------------------------------------------------------------------------------------------------

_BODEN_ON                    EQU     H'3FFF'
_BODEN_OFF                   EQU     H'3FBF'
_CP_ALL                      EQU     H'03FF'
_CP_75                       EQU     H'17FF'
_CP_50                       EQU     H'2BFF'
_CP_OFF                      EQU     H'3FFF'
_DATA_CP_ON                  EQU     H'3EFF'
_DATA_CP_OFF                 EQU     H'3FFF'
_PWRTE_OFF                   EQU     H'3FFF'
_PWRTE_ON                    EQU     H'3FF7'
_WDT_ON                      EQU     H'3FFF'
_WDT_OFF                     EQU     H'3FFB'
_LVP_ON                      EQU     H'3FFF'
_LVP_OFF                     EQU     H'3F7F'
_MCLRE_ON                    EQU     H'3FFF'
_MCLRE_OFF                   EQU     H'3FDF'
_ER_OSC_CLKOUT               EQU     H'3FFF'
_ER_OSC_NOCLKOUT             EQU     H'3FFE'
_INTRC_OSC_CLKOUT            EQU     H'3FFD'
_INTRC_OSC_NOCLKOUT          EQU     H'3FFC'
_EXTCLK_OSC                  EQU     H'3FEF'
_LP_OSC                      EQU     H'3FEC'
_XT_OSC                      EQU     H'3FED'
_HS_OSC                      EQU     H'3FEE'




;  ------------------------------------------------------------------------------------

    __CONFIG    _CP_OFF & _WDT_ON & _PWRTE_ON & _XT_OSC & _MCLRE_OFF & _LVP_OFF & _DATA_CP_OFF & _BODEN_OFF




;  ---------------------------------------------------------------------------------------

#define TMR_VALUE               0xCE    ;   60 
#define COIL_OFF_VALUE          0x60    ;    4 
#define MODUL_CONFIG_METAL              ;  -: 
#define FUNC1_ENGINE_STOP               ;   1: -
#define FUNC2_OVERRUN                   ;   2:  
#define FUNC2_OVERRUN_LIMIT     .47     ;       3500/




;   / ------------------------------------------------------------------

#define pLED_N              PORTA,2     ;   
#define pSENSOR             PORTB,1     ;   
#define pCOIL               PORTB,2     ;   
#define pCOIL_N             PORTB,3     ;    
#define pFUNC1_N            PORTB,4     ;    1
#define pFUNC2_N            PORTB,5     ;    2
#define pSELECT1_N          PORTB,6     ;    1
#define pSELECT2_N          PORTB,7     ;    2




;   ------------------------------------------------------------------------------------

#define SENSOR_MASK         0x02        ;   
#define FUNC1_MASK          0x10        ;    1
#define FUNC2_MASK          0x20        ;    2
#define SELECT1_MASK        0x40        ;    1
#define SELECT2_MASK        0x80        ;    2




;    / (0 - , 1 - ) ------------------------------------

#define PORTA_IO            0x00        ;  A
#define PORTB_IO            0xF2        ;  B




;    ----------------------------------------------------------------------

#define PORTA_RESET         0x04        ;  A
#define PORTB_RESET         0x08        ;  B



;   -----------------------------------------------------------------------------------

TmpW                    EQU 0x20        ;  W
TmpSTATUS               EQU 0x21        ;  STATUS
Flags                   EQU 0x22        ;  
Ports                   EQU 0x23        ;   
SensCnt                 EQU 0x24        ;    
SectorCnt               EQU 0x25        ;  
LastSectorCnt           EQU 0x26        ;    
SparkTime               EQU 0x27        ;   
CoilCnt_0               EQU 0x28        ;    
CoilCnt_1               EQU 0x29
CoilOffCnt_0            EQU 0x2A        ;      
CoilOffCnt_1            EQU 0x2B
Func1Cnt                EQU 0x2C        ;     FUNC1
Func2Cnt                EQU 0x2D        ;     FUNC2
Select1Cnt              EQU 0x2E        ;     SELECT1
Select2Cnt              EQU 0x2F        ;     SELECT2
WarmingCnt              EQU 0x30        ;   




;   ------------------------------------------------------------------------------

#define bLastState          Flags,0     ;     
#define bOverflow           Flags,1     ;  
#define bCoilOff            Flags,2     ;    
#define bEngineStop         Flags,3     ;  
#define bOverrun1           Flags,4     ;      1
#define bOverrun2           Flags,5     ;      2

#define bSens               Ports,1     ;       
#define bFunc1_n            Ports,4     ;    1
#define bFunc2_n            Ports,5     ;    2
#define bSelect1_n          Ports,6     ;    1
#define bSelect2_n          Ports,7     ;    2




;   -----------------------------------------------------------------------------------

    ORG	0x0000

    clrwdt

    clrf    INTCON              ;   

    goto Start                  ;    




;   -------------------------------------------------------------------------------

    ORG	0x0004


; Interrupt ---------------------------------------------------------------------------------------
;
; :   TMR0.         . 
;               .
;--------------------------------------------------------------------------------------------------

Interrupt;

    clrwdt

    movwf   TmpW                ;  
    swapf   STATUS,W
    movwf   TmpSTATUS


    movlw   TMR_VALUE           ;  
    movwf   TMR0

    bcf     INTCON,T0IF         ;   


    movf    PORTB,W             ;      
    xorwf   Ports,W
    andlw   SENSOR_MASK
    btfsc   STATUS,Z
    clrf    SensCnt             ;   
    incf    SensCnt,F
    btfss   SensCnt,2           ;   4
    goto $+.4
    movlw   SENSOR_MASK         ;   
    xorwf   Ports,F
    clrf    SensCnt


#ifdef MODUL_CONFIG_METAL

    btfss   bSens               ;    (1 -   , 0 -  )
    goto _Out

#else ; #ifdef MODUL_CONFIG_SPACE

    btfsc   bSens               ;     (0 -   , 1 -  )
    goto _Out

#endif


    btfsc   bLastState          ;    
    goto _SensorActive




_SensorIn                       ;    

    btfsc   bEngineStop         ;    
    goto $+.7
    btfsc   bOverrun1           ;      1
    goto $+.5
    btfsc   bOverrun2           ;      2
    goto $+.3
    bsf     pCOIL               ;   
    bcf     pCOIL_N


    movf    SectorCnt,W         ;   
    movwf   LastSectorCnt

    bsf     bLastState          ;     
    clrf    SectorCnt           ;  
    bcf     bOverflow           ;   

    clrf    CoilOffCnt_1        ;    ,  
    bcf     bCoilOff            ;    ,  

    goto _ExitInterrupt




_SensorActive                   ;      

    bcf     pLED_N              ;  

    btfsc   bOverflow           ;    ,      
    goto _ExitInterrupt

    incf    SectorCnt,F         ;   

    movf    SectorCnt,W         ;     ( 239)
    xorlw   .239
    btfsc   STATUS,Z
    bsf     bOverflow           ;  ,  

    movf    SparkTime,W         ;     ,     0 (..  )
    btfsc   STATUS,Z
    goto _ExitInterrupt         ;  ,        
    xorwf   SectorCnt,W
    btfss   STATUS,Z
    goto _ExitInterrupt

    bcf     pCOIL               ;  
    bsf     pCOIL_N

    goto _ExitInterrupt




_Out                            ;   

    btfss   bLastState          ;    
    goto _SensorIdle




_SensorOut                      ;    

    bcf     pCOIL               ;  ,      ()
    bsf     pCOIL_N

    bcf     bLastState          ;     

    clrf    CoilCnt_0           ;    
    clrf    CoilCnt_1


    movf    SparkTime,W         ;     ~70%
    btfsc   STATUS,Z
    movlw   .239
    addwf   SectorCnt,W
    movwf   CoilCnt_0
    rlf     CoilCnt_1,F

    call CalculateSparkTime     ;   
    movwf   SparkTime

    goto _ExitInterrupt




_SensorIdle                     ;    

    bsf     pLED_N              ;  

    decf    CoilCnt_0,F         ;    
    btfss   STATUS,Z
    goto _ExitInterrupt
    movf    CoilCnt_1,W
    btfsc   STATUS,Z
    goto $+.3
    decf    CoilCnt_1,F
    goto _ExitInterrupt

    btfsc   bEngineStop         ;    
    goto $+.9
    btfsc   bCoilOff            ;     
    goto $+.7
    btfsc   bOverrun1           ;      1
    goto $+.5
    btfsc   bOverrun2           ;      2
    goto $+.3
    bsf     pCOIL               ;   
    bcf     pCOIL_N




_ExitInterrupt

    swapf   TmpSTATUS,W         ;  
    movwf   STATUS
    swapf   TmpW,F
    swapf   TmpW,W

    retfie




; Start -------------------------------------------------------------------------------------------
;
; :  ,       , 
;             .
;--------------------------------------------------------------------------------------------------

Start;


#ifdef PIC16F628

    movlw   0x07                ;   ( PIC16F628)
    movwf   CMCON

#endif


    bsf     STATUS,RP0          ;    1


    clrf    EECON1              ;   / 

    movlw   PORTA_IO            ;    (1 - , 0 - )
    movwf   TRISA
    movlw   PORTB_IO
    movwf   TRISB

    movlw   0x88                ;   PB ,   WDT
    movwf   OPTION_REG


    bcf     STATUS,RP0          ;    0


    movlw   PORTA_RESET         ;   
    movwf   PORTA
    movlw   PORTB_RESET
    movwf   PORTB


    clrf    Flags               ;  
    clrf    SectorCnt
    clrf    LastSectorCnt
    clrf    SparkTime
    clrf    CoilCnt_0
    clrf    CoilCnt_1
    clrf    CoilOffCnt_0
    clrf    CoilOffCnt_1


    movf    PORTB,W             ;    
    andlw   SENSOR_MASK | FUNC1_MASK | FUNC2_MASK  | SELECT1_MASK | SELECT2_MASK
    movwf   Ports


#ifdef FUNC1_ENGINE_STOP        ;   

    btfsc   bFunc1_n            ;   
    goto $+.3
    bsf     bEngineStop         ;  
    goto $+.2
    bcf     bEngineStop         ;  

#endif


#ifdef FUNC2_ENGINE_STOP        ;   

    btfsc   bFunc2_n            ;   
    goto $+.3
    bsf     bEngineStop         ;  
    goto $+.2
    bcf     bEngineStop         ;  

#endif




#ifdef MODUL_CONFIG_METAL

    btfss   pSENSOR             ;    
    goto $+.8

#else ; #ifdef MODUL_CONFIG_SPACE

    btfsc   pSENSOR             ;      (fix 1.51)
    goto $+.8

#endif

                                ;   
    bcf     pLED_N              ;  
    bsf     bLastState          ;    
    btfsc   bEngineStop         ;    
    goto $+.3
    bsf     pCOIL               ;   
    bcf     pCOIL_N
    goto $+.5
                                ;   
    bsf     pLED_N              ;  
    bcf     bLastState          ;    
    bcf     pCOIL               ;   
    bsf     pCOIL_N


    movlw   TMR_VALUE           ;  
    movwf   TMR0


    movlw   0xA0                ;    TMR0,   ,   
    movwf   INTCON




_MainLoop

    bsf     INTCON,T0IE         ;    TMR0
    bsf     INTCON,GIE          ;   


                                ;      
    incf    CoilOffCnt_0,F
    btfsc   STATUS,Z
    incf    CoilOffCnt_1,F

    movf    CoilOffCnt_1,W      ;     
    xorlw   COIL_OFF_VALUE
    btfss   STATUS,Z
    goto $+.6
    bcf     INTCON,GIE          ;  
    bcf     pCOIL               ;   (fix 1.51)
    bsf     pCOIL_N
    clrf    CoilOffCnt_1        ;    
    bsf     bCoilOff            ;    


                                ;     1
    movf    PORTB,W
    xorwf   Ports,W
    andlw   FUNC1_MASK
    btfsc   STATUS,Z
    clrf    Func1Cnt            ;  
    incf    Func1Cnt,F
    btfss   STATUS,Z            ;   0
    goto $+.3
    movlw   FUNC1_MASK          ;   
    xorwf   Ports,F


                                ;     2
    movf    PORTB,W
    xorwf   Ports,W
    andlw   FUNC2_MASK
    btfsc   STATUS,Z
    clrf    Func2Cnt            ;  
    incf    Func2Cnt,F
    btfss   STATUS,Z            ;   0
    goto $+.3
    movlw   FUNC2_MASK          ;   
    xorwf   Ports,F


                                ;     1
    movf    PORTB,W
    xorwf   Ports,W
    andlw   SELECT1_MASK
    btfsc   STATUS,Z
    clrf    Select1Cnt          ;  
    incf    Select1Cnt,F
    btfss   STATUS,Z            ;   0
    goto $+.3
    movlw   SELECT1_MASK        ;   
    xorwf   Ports,F


                                ;     2
    movf    PORTB,W
    xorwf   Ports,W
    andlw   SELECT2_MASK
    btfsc   STATUS,Z
    clrf    Select2Cnt          ;  
    incf    Select2Cnt,F
    btfss   STATUS,Z            ;   0
    goto $+.3
    movlw   SELECT2_MASK        ;   
    xorwf   Ports,F




#ifdef FUNC1_ENGINE_STOP        ;   

    btfsc   bFunc1_n            ;   
    goto $+.3
    bsf     bEngineStop         ;  
    goto $+.2
    bcf     bEngineStop         ;  

#endif


#ifdef FUNC1_PROTECT            ;  

    btfsc   bFunc1_n            ;   
    goto $+.11
    movf    LastSectorCnt,W     ;   ,  LastSectorCnt > 0
    btfsc   STATUS,Z
    goto $+.8
    sublw   FUNC1_PROTECT_LIMIT ;    
    btfss   STATUS,C            ;  ,  = 1  W < FUNC1_PROTECT_LIMIT
    goto $+.5
    clrwdt                      ; ̸ ,   
    bcf     INTCON,GIE          ;  
    bcf     pLED_N              ;  
    goto $-.3

#endif


#ifdef FUNC1_OVERRUN            ;   

    btfsc   bFunc1_n            ;   
    goto $+.9
    movf    LastSectorCnt,W     ;   ,  LastSectorCnt > 0
    btfsc   STATUS,Z
    goto $+.7
    sublw   FUNC1_OVERRUN_LIMIT ;    
    btfss   STATUS,C            ;  ,  = 1  W < FUNC1_OVERRUN_LIMIT
    goto $+.3
    bsf     bOverrun1           ;    
    goto $+.2
    bcf     bOverrun1           ;    

#endif


#ifdef FUNC1_WARMING_SPARK      ;    (1.6)

    btfss   bFunc1_n            ;   
    btfss   bCoilOff            ;         ( )
    goto $+.13

    clrf    CoilOffCnt_1        ;    

    incf    WarmingCnt,F        ;  

    btfss   STATUS,Z            ;  0  
    goto $+.3
    bsf     pCOIL               ;   
    bcf     pCOIL_N

    movf    WarmingCnt,W        ;     
    sublw   WARMING_COIL_TIME
    btfss   STATUS,Z
    goto $+.3
    bcf     pCOIL               ;   
    bsf     pCOIL_N
                                ;        

#endif


#ifdef FUNC2_ENGINE_STOP        ;   

    btfsc   bFunc2_n            ;   
    goto $+.3
    bsf     bEngineStop         ;  
    goto $+.2
    bcf     bEngineStop         ;  

#endif


#ifdef FUNC2_PROTECT            ;  

    btfsc   bFunc2_n            ;   
    goto $+.11
    movf    LastSectorCnt,W     ;   ,  LastSectorCnt > 0
    btfsc   STATUS,Z
    goto $+.8
    sublw   FUNC2_PROTECT_LIMIT ;    
    btfss   STATUS,C            ;  ,  = 1  W < FUNC2_PROTECT_LIMIT
    goto $+.5
    clrwdt                      ; ̸ ,   
    bcf     INTCON,GIE          ;  
    bcf     pLED_N              ;  
    goto $-.3

#endif


#ifdef FUNC2_OVERRUN            ;   

    btfsc   bFunc2_n            ;   
    goto $+.9
    movf    LastSectorCnt,W     ;   ,  LastSectorCnt > 0
    btfsc   STATUS,Z
    goto $+.7
    sublw   FUNC2_OVERRUN_LIMIT ;    
    btfss   STATUS,C            ;  ,  = 1  W < FUNC2_OVERRUN_LIMIT
    goto $+.3
    bsf     bOverrun2           ;    
    goto $+.2
    bcf     bOverrun2           ;    

#endif


#ifdef FUNC2_WARMING_SPARK      ;    (1.6)

    btfss   bFunc2_n            ;   
    btfss   bCoilOff            ;         ( )
    goto $+.13

    clrf    CoilOffCnt_1        ;    

    incf    WarmingCnt,F        ;  

    btfss   STATUS,Z            ;  0  
    goto $+.3
    bsf     pCOIL               ;   
    bcf     pCOIL_N

    movf    WarmingCnt,W        ;     
    sublw   WARMING_COIL_TIME
    btfss   STATUS,Z
    goto $+.3
    bcf     pCOIL               ;   
    bsf     pCOIL_N
                                ;        

#endif


    goto _MainLoop




; CalculateSparkTime ------------------------------------------------------------------------------
;
; :           
;            .
;  : SectorCnt -     .
;  : W -        .
;--------------------------------------------------------------------------------------------------

CalculateSparkTime;


    movf    SectorCnt,W         ;      (0 - 239)
    sublw   .239
    btfss   STATUS,C
    retlw   .0                  ;   239,   (0 -   )

                                ;       
    btfsc   bSelect1_n
    goto $+.8

    movlw   HIGH Table1         ;   1
    movwf   PCLATH
    movf    SectorCnt,W
    call Table1
    nop
    clrf    PCLATH
    return


    btfsc   bSelect2_n
    goto $+.8

    movlw   HIGH Table2         ;   2
    movwf   PCLATH
    movf    SectorCnt,W
    call Table2
    nop
    clrf    PCLATH
    return


    movlw   HIGH TableDefault   ;    
    movwf   PCLATH
    movf    SectorCnt,W
    call TableDefault
    nop
    clrf    PCLATH
    return




;  1 ---------------------------------------------------------------------------------------
;
;   1.   SELECT1 = 0  SELECT2 = 1.
;--------------------------------------------------------------------------------------------------

    ORG	0x0100

Table1;

    addwf   PCL,F               ;  

    retlw   .000                ; 0
    retlw   .000                ; 1
    retlw   .000                ; 2
    retlw   .000                ; 3
    retlw   .000                ; 4
    retlw   .000                ; 5
    retlw   .000                ; 6
    retlw   .000                ; 7
    retlw   .000                ; 8
    retlw   .000                ; 9
    retlw   .000                ; 10
    retlw   .000                ; 11
    retlw   .000                ; 12
    retlw   .000                ; 13
    retlw   .000                ; 14
    retlw   .000                ; 15
    retlw   .000                ; 16
    retlw   .000                ; 17
    retlw   .000                ; 18
    retlw   .000                ; 19
    retlw   .000                ; 20
    retlw   .000                ; 21
    retlw   .000                ; 22
    retlw   .000                ; 23
    retlw   .009                ; 24
    retlw   .010                ; 25
    retlw   .010                ; 26
    retlw   .011                ; 27
    retlw   .011                ; 28
    retlw   .012                ; 29
    retlw   .013                ; 30
    retlw   .013                ; 31
    retlw   .014                ; 32
    retlw   .014                ; 33
    retlw   .015                ; 34
    retlw   .016                ; 35
    retlw   .016                ; 36
    retlw   .017                ; 37
    retlw   .018                ; 38
    retlw   .018                ; 39
    retlw   .019                ; 40
    retlw   .019                ; 41
    retlw   .020                ; 42
    retlw   .021                ; 43
    retlw   .022                ; 44
    retlw   .023                ; 45
    retlw   .024                ; 46
    retlw   .025                ; 47
    retlw   .025                ; 48
    retlw   .026                ; 49
    retlw   .027                ; 50
    retlw   .028                ; 51
    retlw   .029                ; 52
    retlw   .030                ; 53
    retlw   .031                ; 54
    retlw   .031                ; 55
    retlw   .033                ; 56
    retlw   .034                ; 57
    retlw   .035                ; 58
    retlw   .036                ; 59
    retlw   .037                ; 60
    retlw   .038                ; 61
    retlw   .039                ; 62
    retlw   .040                ; 63
    retlw   .041                ; 64
    retlw   .043                ; 65
    retlw   .044                ; 66
    retlw   .045                ; 67
    retlw   .046                ; 68
    retlw   .047                ; 69
    retlw   .048                ; 70
    retlw   .049                ; 71
    retlw   .050                ; 72
    retlw   .051                ; 73
    retlw   .053                ; 74
    retlw   .054                ; 75
    retlw   .055                ; 76
    retlw   .056                ; 77
    retlw   .057                ; 78
    retlw   .058                ; 79
    retlw   .059                ; 80
    retlw   .060                ; 81
    retlw   .061                ; 82
    retlw   .062                ; 83
    retlw   .064                ; 84
    retlw   .065                ; 85
    retlw   .066                ; 86
    retlw   .067                ; 87
    retlw   .068                ; 88
    retlw   .069                ; 89
    retlw   .070                ; 90
    retlw   .072                ; 91
    retlw   .073                ; 92
    retlw   .074                ; 93
    retlw   .075                ; 94
    retlw   .076                ; 95
    retlw   .077                ; 96
    retlw   .078                ; 97
    retlw   .079                ; 98
    retlw   .081                ; 99
    retlw   .082                ; 100
    retlw   .083                ; 101
    retlw   .084                ; 102
    retlw   .085                ; 103
    retlw   .086                ; 104
    retlw   .087                ; 105
    retlw   .089                ; 106
    retlw   .090                ; 107
    retlw   .091                ; 108
    retlw   .092                ; 109
    retlw   .093                ; 110
    retlw   .094                ; 111
    retlw   .095                ; 112
    retlw   .096                ; 113
    retlw   .098                ; 114
    retlw   .099                ; 115
    retlw   .100                ; 116
    retlw   .101                ; 117
    retlw   .102                ; 118
    retlw   .103                ; 119
    retlw   .104                ; 120
    retlw   .106                ; 121
    retlw   .107                ; 122
    retlw   .108                ; 123
    retlw   .109                ; 124
    retlw   .110                ; 125
    retlw   .111                ; 126
    retlw   .112                ; 127
    retlw   .113                ; 128
    retlw   .115                ; 129
    retlw   .116                ; 130
    retlw   .117                ; 131
    retlw   .118                ; 132
    retlw   .119                ; 133
    retlw   .120                ; 134
    retlw   .121                ; 135
    retlw   .123                ; 136
    retlw   .124                ; 137
    retlw   .125                ; 138
    retlw   .126                ; 139
    retlw   .127                ; 140
    retlw   .128                ; 141
    retlw   .129                ; 142
    retlw   .130                ; 143
    retlw   .132                ; 144
    retlw   .133                ; 145
    retlw   .134                ; 146
    retlw   .135                ; 147
    retlw   .136                ; 148
    retlw   .137                ; 149
    retlw   .138                ; 150
    retlw   .140                ; 151
    retlw   .141                ; 152
    retlw   .142                ; 153
    retlw   .143                ; 154
    retlw   .144                ; 155
    retlw   .145                ; 156
    retlw   .146                ; 157
    retlw   .147                ; 158
    retlw   .149                ; 159
    retlw   .150                ; 160
    retlw   .151                ; 161
    retlw   .152                ; 162
    retlw   .153                ; 163
    retlw   .154                ; 164
    retlw   .155                ; 165
    retlw   .156                ; 166
    retlw   .158                ; 167
    retlw   .159                ; 168
    retlw   .160                ; 169
    retlw   .161                ; 170
    retlw   .162                ; 171
    retlw   .163                ; 172
    retlw   .164                ; 173
    retlw   .166                ; 174
    retlw   .167                ; 175
    retlw   .168                ; 176
    retlw   .169                ; 177
    retlw   .170                ; 178
    retlw   .171                ; 179
    retlw   .172                ; 180
    retlw   .174                ; 181
    retlw   .175                ; 182
    retlw   .176                ; 183
    retlw   .177                ; 184
    retlw   .178                ; 185
    retlw   .179                ; 186
    retlw   .180                ; 187
    retlw   .182                ; 188
    retlw   .183                ; 189
    retlw   .184                ; 190
    retlw   .185                ; 191
    retlw   .186                ; 192
    retlw   .187                ; 193
    retlw   .188                ; 194
    retlw   .190                ; 195
    retlw   .191                ; 196
    retlw   .192                ; 197
    retlw   .193                ; 198
    retlw   .194                ; 199
    retlw   .195                ; 200
    retlw   .196                ; 201
    retlw   .197                ; 202
    retlw   .199                ; 203
    retlw   .200                ; 204
    retlw   .201                ; 205
    retlw   .202                ; 206
    retlw   .203                ; 207
    retlw   .204                ; 208
    retlw   .205                ; 209
    retlw   .207                ; 210
    retlw   .208                ; 211
    retlw   .209                ; 212
    retlw   .210                ; 213
    retlw   .211                ; 214
    retlw   .212                ; 215
    retlw   .213                ; 216
    retlw   .215                ; 217
    retlw   .216                ; 218
    retlw   .217                ; 219
    retlw   .218                ; 220
    retlw   .219                ; 221
    retlw   .220                ; 222
    retlw   .221                ; 223
    retlw   .223                ; 224
    retlw   .224                ; 225
    retlw   .225                ; 226
    retlw   .226                ; 227
    retlw   .227                ; 228
    retlw   .228                ; 229
    retlw   .229                ; 230
    retlw   .231                ; 231
    retlw   .232                ; 232
    retlw   .233                ; 233
    retlw   .234                ; 234
    retlw   .235                ; 235
    retlw   .236                ; 236
    retlw   .237                ; 237
    retlw   .238                ; 238
    retlw   .000                ; 239




;  2 ---------------------------------------------------------------------------------------
;
;   2.   SELECT1 = X (  )  SELECT2 = 0.
;--------------------------------------------------------------------------------------------------

    ORG	0x0200

Table2;

    addwf   PCL,F               ;  

    retlw   .000                ; 0
    retlw   .000                ; 1
    retlw   .000                ; 2
    retlw   .000                ; 3
    retlw   .000                ; 4
    retlw   .000                ; 5
    retlw   .000                ; 6
    retlw   .000                ; 7
    retlw   .000                ; 8
    retlw   .000                ; 9
    retlw   .000                ; 10
    retlw   .000                ; 11
    retlw   .000                ; 12
    retlw   .000                ; 13
    retlw   .000                ; 14
    retlw   .000                ; 15
    retlw   .000                ; 16
    retlw   .000                ; 17
    retlw   .000                ; 18
    retlw   .000                ; 19
    retlw   .000                ; 20
    retlw   .000                ; 21
    retlw   .000                ; 22
    retlw   .000                ; 23
    retlw   .002                ; 24
    retlw   .003                ; 25
    retlw   .003                ; 26
    retlw   .003                ; 27
    retlw   .003                ; 28
    retlw   .004                ; 29
    retlw   .004                ; 30
    retlw   .004                ; 31
    retlw   .004                ; 32
    retlw   .004                ; 33
    retlw   .005                ; 34
    retlw   .005                ; 35
    retlw   .006                ; 36
    retlw   .006                ; 37
    retlw   .006                ; 38
    retlw   .007                ; 39
    retlw   .007                ; 40
    retlw   .007                ; 41
    retlw   .008                ; 42
    retlw   .009                ; 43
    retlw   .009                ; 44
    retlw   .010                ; 45
    retlw   .010                ; 46
    retlw   .011                ; 47
    retlw   .011                ; 48
    retlw   .012                ; 49
    retlw   .013                ; 50
    retlw   .013                ; 51
    retlw   .014                ; 52
    retlw   .014                ; 53
    retlw   .015                ; 54
    retlw   .015                ; 55
    retlw   .016                ; 56
    retlw   .017                ; 57
    retlw   .018                ; 58
    retlw   .019                ; 59
    retlw   .020                ; 60
    retlw   .021                ; 61
    retlw   .022                ; 62
    retlw   .023                ; 63
    retlw   .024                ; 64
    retlw   .024                ; 65
    retlw   .025                ; 66
    retlw   .026                ; 67
    retlw   .027                ; 68
    retlw   .028                ; 69
    retlw   .029                ; 70
    retlw   .030                ; 71
    retlw   .031                ; 72
    retlw   .032                ; 73
    retlw   .032                ; 74
    retlw   .033                ; 75
    retlw   .034                ; 76
    retlw   .035                ; 77
    retlw   .036                ; 78
    retlw   .037                ; 79
    retlw   .038                ; 80
    retlw   .039                ; 81
    retlw   .040                ; 82
    retlw   .040                ; 83
    retlw   .042                ; 84
    retlw   .043                ; 85
    retlw   .044                ; 86
    retlw   .046                ; 87
    retlw   .047                ; 88
    retlw   .048                ; 89
    retlw   .049                ; 90
    retlw   .051                ; 91
    retlw   .052                ; 92
    retlw   .053                ; 93
    retlw   .054                ; 94
    retlw   .056                ; 95
    retlw   .057                ; 96
    retlw   .058                ; 97
    retlw   .059                ; 98
    retlw   .061                ; 99
    retlw   .062                ; 100
    retlw   .063                ; 101
    retlw   .064                ; 102
    retlw   .066                ; 103
    retlw   .067                ; 104
    retlw   .068                ; 105
    retlw   .069                ; 106
    retlw   .071                ; 107
    retlw   .072                ; 108
    retlw   .073                ; 109
    retlw   .074                ; 110
    retlw   .076                ; 111
    retlw   .077                ; 112
    retlw   .078                ; 113
    retlw   .079                ; 114
    retlw   .081                ; 115
    retlw   .082                ; 116
    retlw   .083                ; 117
    retlw   .084                ; 118
    retlw   .086                ; 119
    retlw   .087                ; 120
    retlw   .088                ; 121
    retlw   .089                ; 122
    retlw   .091                ; 123
    retlw   .092                ; 124
    retlw   .093                ; 125
    retlw   .094                ; 126
    retlw   .096                ; 127
    retlw   .097                ; 128
    retlw   .098                ; 129
    retlw   .099                ; 130
    retlw   .101                ; 131
    retlw   .102                ; 132
    retlw   .103                ; 133
    retlw   .104                ; 134
    retlw   .106                ; 135
    retlw   .107                ; 136
    retlw   .108                ; 137
    retlw   .109                ; 138
    retlw   .111                ; 139
    retlw   .112                ; 140
    retlw   .113                ; 141
    retlw   .114                ; 142
    retlw   .116                ; 143
    retlw   .117                ; 144
    retlw   .118                ; 145
    retlw   .119                ; 146
    retlw   .121                ; 147
    retlw   .122                ; 148
    retlw   .123                ; 149
    retlw   .124                ; 150
    retlw   .126                ; 151
    retlw   .127                ; 152
    retlw   .128                ; 153
    retlw   .129                ; 154
    retlw   .131                ; 155
    retlw   .132                ; 156
    retlw   .133                ; 157
    retlw   .134                ; 158
    retlw   .136                ; 159
    retlw   .137                ; 160
    retlw   .138                ; 161
    retlw   .139                ; 162
    retlw   .141                ; 163
    retlw   .142                ; 164
    retlw   .143                ; 165
    retlw   .144                ; 166
    retlw   .146                ; 167
    retlw   .147                ; 168
    retlw   .148                ; 169
    retlw   .150                ; 170
    retlw   .151                ; 171
    retlw   .152                ; 172
    retlw   .154                ; 173
    retlw   .155                ; 174
    retlw   .156                ; 175
    retlw   .158                ; 176
    retlw   .159                ; 177
    retlw   .160                ; 178
    retlw   .161                ; 179
    retlw   .163                ; 180
    retlw   .164                ; 181
    retlw   .165                ; 182
    retlw   .167                ; 183
    retlw   .168                ; 184
    retlw   .169                ; 185
    retlw   .171                ; 186
    retlw   .172                ; 187
    retlw   .173                ; 188
    retlw   .175                ; 189
    retlw   .176                ; 190
    retlw   .177                ; 191
    retlw   .178                ; 192
    retlw   .180                ; 193
    retlw   .181                ; 194
    retlw   .182                ; 195
    retlw   .184                ; 196
    retlw   .185                ; 197
    retlw   .186                ; 198
    retlw   .188                ; 199
    retlw   .189                ; 200
    retlw   .190                ; 201
    retlw   .191                ; 202
    retlw   .193                ; 203
    retlw   .194                ; 204
    retlw   .195                ; 205
    retlw   .197                ; 206
    retlw   .198                ; 207
    retlw   .199                ; 208
    retlw   .201                ; 209
    retlw   .202                ; 210
    retlw   .203                ; 211
    retlw   .205                ; 212
    retlw   .206                ; 213
    retlw   .207                ; 214
    retlw   .208                ; 215
    retlw   .210                ; 216
    retlw   .211                ; 217
    retlw   .212                ; 218
    retlw   .214                ; 219
    retlw   .215                ; 220
    retlw   .216                ; 221
    retlw   .218                ; 222
    retlw   .219                ; 223
    retlw   .220                ; 224
    retlw   .222                ; 225
    retlw   .223                ; 226
    retlw   .224                ; 227
    retlw   .225                ; 228
    retlw   .227                ; 229
    retlw   .228                ; 230
    retlw   .229                ; 231
    retlw   .231                ; 232
    retlw   .232                ; 233
    retlw   .233                ; 234
    retlw   .235                ; 235
    retlw   .236                ; 236
    retlw   .237                ; 237
    retlw   .238                ; 238
    retlw   .000                ; 239




;  3 ---------------------------------------------------------------------------------------
;
;    .   SELECT1 = 1  SELECT2 = 1.
;--------------------------------------------------------------------------------------------------

    ORG	0x0300

TableDefault;

    addwf   PCL,F               ;  

    retlw   .000                ; 0
    retlw   .000                ; 1
    retlw   .000                ; 2
    retlw   .000                ; 3
    retlw   .000                ; 4
    retlw   .000                ; 5
    retlw   .000                ; 6
    retlw   .000                ; 7
    retlw   .000                ; 8
    retlw   .000                ; 9
    retlw   .000                ; 10
    retlw   .000                ; 11
    retlw   .000                ; 12
    retlw   .000                ; 13
    retlw   .000                ; 14
    retlw   .000                ; 15
    retlw   .000                ; 16
    retlw   .000                ; 17
    retlw   .000                ; 18
    retlw   .000                ; 19
    retlw   .000                ; 20
    retlw   .000                ; 21
    retlw   .000                ; 22
    retlw   .000                ; 23
    retlw   .004                ; 24
    retlw   .005                ; 25
    retlw   .005                ; 26
    retlw   .005                ; 27
    retlw   .005                ; 28
    retlw   .006                ; 29
    retlw   .007                ; 30
    retlw   .007                ; 31
    retlw   .008                ; 32
    retlw   .008                ; 33
    retlw   .009                ; 34
    retlw   .010                ; 35
    retlw   .010                ; 36
    retlw   .011                ; 37
    retlw   .012                ; 38
    retlw   .012                ; 39
    retlw   .013                ; 40
    retlw   .013                ; 41
    retlw   .014                ; 42
    retlw   .015                ; 43
    retlw   .016                ; 44
    retlw   .016                ; 45
    retlw   .017                ; 46
    retlw   .018                ; 47
    retlw   .018                ; 48
    retlw   .019                ; 49
    retlw   .020                ; 50
    retlw   .021                ; 51
    retlw   .021                ; 52
    retlw   .022                ; 53
    retlw   .023                ; 54
    retlw   .023                ; 55
    retlw   .025                ; 56
    retlw   .026                ; 57
    retlw   .027                ; 58
    retlw   .028                ; 59
    retlw   .029                ; 60
    retlw   .030                ; 61
    retlw   .031                ; 62
    retlw   .032                ; 63
    retlw   .033                ; 64
    retlw   .034                ; 65
    retlw   .035                ; 66
    retlw   .036                ; 67
    retlw   .037                ; 68
    retlw   .038                ; 69
    retlw   .039                ; 70
    retlw   .040                ; 71
    retlw   .041                ; 72
    retlw   .042                ; 73
    retlw   .043                ; 74
    retlw   .044                ; 75
    retlw   .045                ; 76
    retlw   .046                ; 77
    retlw   .047                ; 78
    retlw   .048                ; 79
    retlw   .049                ; 80
    retlw   .050                ; 81
    retlw   .051                ; 82
    retlw   .052                ; 83
    retlw   .054                ; 84
    retlw   .055                ; 85
    retlw   .056                ; 86
    retlw   .057                ; 87
    retlw   .059                ; 88
    retlw   .060                ; 89
    retlw   .061                ; 90
    retlw   .062                ; 91
    retlw   .063                ; 92
    retlw   .065                ; 93
    retlw   .066                ; 94
    retlw   .067                ; 95
    retlw   .068                ; 96
    retlw   .070                ; 97
    retlw   .071                ; 98
    retlw   .072                ; 99
    retlw   .073                ; 100
    retlw   .074                ; 101
    retlw   .076                ; 102
    retlw   .077                ; 103
    retlw   .078                ; 104
    retlw   .079                ; 105
    retlw   .080                ; 106
    retlw   .082                ; 107
    retlw   .083                ; 108
    retlw   .084                ; 109
    retlw   .085                ; 110
    retlw   .087                ; 111
    retlw   .088                ; 112
    retlw   .089                ; 113
    retlw   .090                ; 114
    retlw   .091                ; 115
    retlw   .093                ; 116
    retlw   .094                ; 117
    retlw   .095                ; 118
    retlw   .096                ; 119
    retlw   .098                ; 120
    retlw   .099                ; 121
    retlw   .100                ; 122
    retlw   .101                ; 123
    retlw   .102                ; 124
    retlw   .104                ; 125
    retlw   .105                ; 126
    retlw   .106                ; 127
    retlw   .107                ; 128
    retlw   .108                ; 129
    retlw   .110                ; 130
    retlw   .111                ; 131
    retlw   .112                ; 132
    retlw   .113                ; 133
    retlw   .115                ; 134
    retlw   .116                ; 135
    retlw   .117                ; 136
    retlw   .118                ; 137
    retlw   .119                ; 138
    retlw   .121                ; 139
    retlw   .122                ; 140
    retlw   .123                ; 141
    retlw   .124                ; 142
    retlw   .126                ; 143
    retlw   .127                ; 144
    retlw   .128                ; 145
    retlw   .129                ; 146
    retlw   .130                ; 147
    retlw   .132                ; 148
    retlw   .133                ; 149
    retlw   .134                ; 150
    retlw   .135                ; 151
    retlw   .136                ; 152
    retlw   .138                ; 153
    retlw   .139                ; 154
    retlw   .140                ; 155
    retlw   .141                ; 156
    retlw   .143                ; 157
    retlw   .144                ; 158
    retlw   .145                ; 159
    retlw   .146                ; 160
    retlw   .147                ; 161
    retlw   .149                ; 162
    retlw   .150                ; 163
    retlw   .151                ; 164
    retlw   .152                ; 165
    retlw   .153                ; 166
    retlw   .155                ; 167
    retlw   .156                ; 168
    retlw   .157                ; 169
    retlw   .158                ; 170
    retlw   .159                ; 171
    retlw   .161                ; 172
    retlw   .162                ; 173
    retlw   .163                ; 174
    retlw   .164                ; 175
    retlw   .165                ; 176
    retlw   .166                ; 177
    retlw   .168                ; 178
    retlw   .169                ; 179
    retlw   .170                ; 180
    retlw   .171                ; 181
    retlw   .172                ; 182
    retlw   .174                ; 183
    retlw   .175                ; 184
    retlw   .176                ; 185
    retlw   .177                ; 186
    retlw   .178                ; 187
    retlw   .179                ; 188
    retlw   .181                ; 189
    retlw   .182                ; 190
    retlw   .183                ; 191
    retlw   .184                ; 192
    retlw   .185                ; 193
    retlw   .187                ; 194
    retlw   .188                ; 195
    retlw   .189                ; 196
    retlw   .190                ; 197
    retlw   .191                ; 198
    retlw   .192                ; 199
    retlw   .194                ; 200
    retlw   .195                ; 201
    retlw   .196                ; 202
    retlw   .197                ; 203
    retlw   .198                ; 204
    retlw   .200                ; 205
    retlw   .201                ; 206
    retlw   .202                ; 207
    retlw   .203                ; 208
    retlw   .204                ; 209
    retlw   .205                ; 210
    retlw   .207                ; 211
    retlw   .208                ; 212
    retlw   .209                ; 213
    retlw   .210                ; 214
    retlw   .211                ; 215
    retlw   .213                ; 216
    retlw   .214                ; 217
    retlw   .215                ; 218
    retlw   .216                ; 219
    retlw   .217                ; 220
    retlw   .218                ; 221
    retlw   .220                ; 222
    retlw   .221                ; 223
    retlw   .222                ; 224
    retlw   .223                ; 225
    retlw   .224                ; 226
    retlw   .226                ; 227
    retlw   .227                ; 228
    retlw   .228                ; 229
    retlw   .229                ; 230
    retlw   .230                ; 231
    retlw   .231                ; 232
    retlw   .233                ; 233
    retlw   .234                ; 234
    retlw   .235                ; 235
    retlw   .236                ; 236
    retlw   .237                ; 237
    retlw   .238                ; 238
    retlw   .000                ; 239



    END
